commit:     0ca12ba030358b6e399d2537eb1b5ebf1cbfc41f
Author:     Michał Górny <mgorny <AT> gentoo <DOT> org>
AuthorDate: Sun Feb  7 21:57:44 2021 +0000
Commit:     Michał Górny <mgorny <AT> gentoo <DOT> org>
CommitDate: Sun Feb  7 23:04:47 2021 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=0ca12ba0

dev-python/numpy: Bump to 1.20.1

Signed-off-by: Michał Górny <mgorny <AT> gentoo.org>

 dev-python/numpy/Manifest                          |   1 +
 .../files/numpy-1.20.1-no-hardcode-blasv2.patch    |  50 +++++++
 dev-python/numpy/numpy-1.20.1.ebuild               | 145 +++++++++++++++++++++
 profiles/package.mask                              |   5 +
 4 files changed, 201 insertions(+)

diff --git a/dev-python/numpy/Manifest b/dev-python/numpy/Manifest
index 9879a80cc89..8d28131121a 100644
--- a/dev-python/numpy/Manifest
+++ b/dev-python/numpy/Manifest
@@ -1,5 +1,6 @@
 DIST numpy-1.19.4.zip 7315971 BLAKE2B 
4809ad6aaf7f9893ea6ed4c2456f4827aa5728b9dba00ed4c8e517267dd299933ca6c9205e3e31ef61ba25a6c13dde32dbe7d268c2d54391bd532d368bb3c5e8
 SHA512 
ae8e6b2792022c147159a11188f9702fa9fa9c9707c834da4f21aa43752451509b0a5b8807d93dfa86dff7e95c127dab20e4f372336a66f25f9b56c2869a486f
 DIST numpy-1.19.5.zip 7318340 BLAKE2B 
a01fd07d8cbfc53c1585b19701f9052fd4b1b4010d24c61e1054352a80343e6644ae6e61ce7565fd9c7c99b9e1174bdd2e685fd5666640d08b1ec9919f86cc8e
 SHA512 
dfe2809b5f486624b4802ea5610822bf7ba80c46dcf8505f69b0267137b01719131f74aa366949954c66796d48ba1b4f74cf0ecc5692a9ebd49e673fb0881ff4
+DIST numpy-1.20.1.zip 7750776 BLAKE2B 
0f3915f2e8dfa6e0e7a6251fcba5365379d91b448101513860573f07e1f3fa24b097177a333230d7cbea1f58afed1718346d0348d14344544fe063e4baa6786a
 SHA512 
edd1be2df27940f050ebd8eeb7b053b9987849d3b4aa0cb3c75d2fe2318f358e1b37f3bafedc772c224021e9316ebce45e1b75aa0e35d248f8ba9a9112b57b86
 DIST numpy-html-1.16.4.zip 12097069 BLAKE2B 
db1f897342fbc80a761fbaee7b0eee3761dbfa04ef6c46a137bb2392caaec8256580467ce06498cceeada2639151a1ec75dafab484d64cb897c008727d6d32a5
 SHA512 
c44c5e1e0cb22f9dd46fe9e302030292d85e567456178fee296746a414271634e906509fb6665ac63fbfebdd13c5383574f0aa47b4fbc639063da31addc3316a
 DIST numpy-ref-1.16.4.pdf 5176571 BLAKE2B 
9a875ebd1473b241d463d810a6d191581aef961158f2f82959671b554ace3ad482795e4f3e1cb7dd4632cff926c1e864c675a7624fb0f4e4f297948bf50f0564
 SHA512 
983ba0f34a70c011886bdbc9fd8f3f75a3a967ca29217acc76fa46e7da391296a5628c9a557ac76efb393271abfb8ee4f376d401c1cc1e5c30622e54b9325d09
 DIST numpy-user-1.16.4.pdf 596203 BLAKE2B 
da3ad1f0ec1c965d20656f73a970911cbb58efa73a5df89e2e6485e0dd763f483e35eea1395ac919bf35d496fb216cee954fc5d31edebc1796a24a2a7a2d12b9
 SHA512 
3083008547213bfa98ffa5cd8e2cea13f6947f42d83aef61502a2a852b0d5f27d727c76b42d281d7a2f4f76c78e88b12ee3d9b164b39fe1f0213ace7097357d6

diff --git a/dev-python/numpy/files/numpy-1.20.1-no-hardcode-blasv2.patch 
b/dev-python/numpy/files/numpy-1.20.1-no-hardcode-blasv2.patch
new file mode 100644
index 00000000000..e24e0edb926
--- /dev/null
+++ b/dev-python/numpy/files/numpy-1.20.1-no-hardcode-blasv2.patch
@@ -0,0 +1,50 @@
+diff --git a/numpy/distutils/system_info.py b/numpy/distutils/system_info.py
+index 13f9da0..b696ef5 100644
+--- a/numpy/distutils/system_info.py
++++ b/numpy/distutils/system_info.py
+@@ -505,32 +505,7 @@ def get_info(name, notfound_action=0):
+       1 - display warning message
+       2 - raise error
+     """
+-    cl = {'atlas': atlas_info,  # use lapack_opt or blas_opt instead
+-          'atlas_threads': atlas_threads_info,                # ditto
+-          'atlas_blas': atlas_blas_info,
+-          'atlas_blas_threads': atlas_blas_threads_info,
+-          'lapack_atlas': lapack_atlas_info,  # use lapack_opt instead
+-          'lapack_atlas_threads': lapack_atlas_threads_info,  # ditto
+-          'atlas_3_10': atlas_3_10_info,  # use lapack_opt or blas_opt instead
+-          'atlas_3_10_threads': atlas_3_10_threads_info,                # 
ditto
+-          'atlas_3_10_blas': atlas_3_10_blas_info,
+-          'atlas_3_10_blas_threads': atlas_3_10_blas_threads_info,
+-          'lapack_atlas_3_10': lapack_atlas_3_10_info,  # use lapack_opt 
instead
+-          'lapack_atlas_3_10_threads': lapack_atlas_3_10_threads_info,  # 
ditto
+-          'flame': flame_info,          # use lapack_opt instead
+-          'mkl': mkl_info,
+-          # openblas which may or may not have embedded lapack
+-          'openblas': openblas_info,          # use blas_opt instead
+-          # openblas with embedded lapack
+-          'openblas_lapack': openblas_lapack_info, # use blas_opt instead
+-          'openblas_clapack': openblas_clapack_info, # use blas_opt instead
+-          'blis': blis_info,                  # use blas_opt instead
+-          'lapack_mkl': lapack_mkl_info,      # use lapack_opt instead
+-          'blas_mkl': blas_mkl_info,          # use blas_opt instead
+-          'openblas64_': openblas64__info,
+-          'openblas64__lapack': openblas64__lapack_info,
+-          'openblas_ilp64': openblas_ilp64_info,
+-          'openblas_ilp64_lapack': openblas_ilp64_lapack_info,
++    cl = {'flame': flame_info,          # use lapack_opt instead
+           'x11': x11_info,
+           'fft_opt': fft_opt_info,
+           'fftw': fftw_info,
+@@ -950,10 +925,7 @@ class system_info:
+         return [b for b in [a.strip() for a in libs.split(',')] if b]
+ 
+     def get_libraries(self, key='libraries'):
+-        if hasattr(self, '_lib_names'):
+-            return self.get_libs(key, default=self._lib_names)
+-        else:
+-            return self.get_libs(key, '')
++        return self.get_libs(key, '')
+ 
+     def library_extensions(self):
+         c = customized_ccompiler()

diff --git a/dev-python/numpy/numpy-1.20.1.ebuild 
b/dev-python/numpy/numpy-1.20.1.ebuild
new file mode 100644
index 00000000000..fe497e494ab
--- /dev/null
+++ b/dev-python/numpy/numpy-1.20.1.ebuild
@@ -0,0 +1,145 @@
+# Copyright 1999-2021 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python3_{7..9} )
+PYTHON_REQ_USE="threads(+)"
+
+FORTRAN_NEEDED=lapack
+
+DISTUTILS_USE_SETUPTOOLS=rdepend
+
+inherit distutils-r1 flag-o-matic fortran-2 multiprocessing toolchain-funcs
+
+DOC_PV="1.16.4"
+DESCRIPTION="Fast array and numerical python library"
+HOMEPAGE="https://numpy.org/";
+SRC_URI="
+       mirror://pypi/${PN:0:1}/${PN}/${P}.zip
+       doc? (
+               https://numpy.org/doc/$(ver_cut 1-2 ${DOC_PV})/numpy-html.zip 
-> numpy-html-${DOC_PV}.zip
+               https://numpy.org/doc/$(ver_cut 1-2 ${DOC_PV})/numpy-ref.pdf -> 
numpy-ref-${DOC_PV}.pdf
+               https://numpy.org/doc/$(ver_cut 1-2 ${DOC_PV})/numpy-user.pdf 
-> numpy-user-${DOC_PV}.pdf
+       )"
+LICENSE="BSD"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~mips ~ppc ~ppc64 ~riscv ~s390 
~sparc ~x86 ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos ~sparc-solaris 
~x64-solaris ~x86-solaris"
+IUSE="doc lapack"
+
+RDEPEND="
+       lapack? (
+               >=virtual/cblas-3.8
+               >=virtual/lapack-3.8
+       )
+"
+BDEPEND="
+       ${RDEPEND}
+       app-arch/unzip
+       >=dev-python/cython-0.29.21[${PYTHON_USEDEP}]
+       lapack? ( virtual/pkgconfig )
+       test? (
+               >=dev-python/hypothesis-5.8.0[${PYTHON_USEDEP}]
+               >=dev-python/pytz-2019.3[${PYTHON_USEDEP}]
+               >=dev-python/cffi-1.14.0[${PYTHON_USEDEP}]
+       )
+"
+
+PATCHES=(
+       "${FILESDIR}"/${PN}-1.20.1-no-hardcode-blasv2.patch
+)
+
+distutils_enable_tests pytest
+
+src_unpack() {
+       default
+       if use doc; then
+               unzip -qo "${DISTDIR}"/numpy-html-${DOC_PV}.zip -d html || die
+       fi
+}
+
+python_prepare_all() {
+       if use lapack; then
+               local incdir="${EPREFIX}"/usr/include
+               local libdir="${EPREFIX}"/usr/$(get_libdir)
+               cat >> site.cfg <<-EOF || die
+                       [blas]
+                       include_dirs = ${incdir}
+                       library_dirs = ${libdir}
+                       blas_libs = cblas,blas
+                       [lapack]
+                       library_dirs = ${libdir}
+                       lapack_libs = lapack
+               EOF
+       else
+               export {ATLAS,PTATLAS,BLAS,LAPACK,MKL}=None
+       fi
+
+       export CC="$(tc-getCC) ${CFLAGS}"
+
+       append-flags -fno-strict-aliasing
+
+       # See progress in http://projects.scipy.org/scipy/numpy/ticket/573
+       # with the subtle difference that we don't want to break Darwin where
+       # -shared is not a valid linker argument
+       if [[ ${CHOST} != *-darwin* ]]; then
+               append-ldflags -shared
+       fi
+
+       # only one fortran to link with:
+       # linking with cblas and lapack library will force
+       # autodetecting and linking to all available fortran compilers
+       append-fflags -fPIC
+       if use lapack; then
+               NUMPY_FCONFIG="config_fc --noopt --noarch"
+               # workaround bug 335908
+               [[ $(tc-getFC) == *gfortran* ]] && NUMPY_FCONFIG+=" 
--fcompiler=gnu95"
+       fi
+
+       # don't version f2py, we will handle it.
+       sed -i -e '/f2py_exe/s: + os\.path.*$::' numpy/f2py/setup.py || die
+
+       # disable fuzzed tests
+       find numpy/*/tests -name '*.py' -exec sed -i \
+               -e 's:def \(.*_fuzz\):def _\1:' {} + || die
+       # very memory- and disk-hungry
+       sed -i -e 's:test_large_zip:_&:' numpy/lib/tests/test_io.py || die
+
+       distutils-r1_python_prepare_all
+}
+
+python_compile() {
+       export MAKEOPTS=-j1 #660754
+
+       distutils-r1_python_compile ${NUMPY_FCONFIG}
+}
+
+python_test() {
+       distutils_install_for_testing --single-version-externally-managed \
+               --record "${TMPDIR}/record.txt" ${NUMPY_FCONFIG}
+
+       cd "${TMPDIR}" || die
+
+       "${EPYTHON}" -c "
+import numpy, sys
+r = numpy.test(label='full', verbose=3)
+sys.exit(0 if r else 1)" || die "Tests fail with ${EPYTHON}"
+}
+
+python_install() {
+       # https://github.com/numpy/numpy/issues/16005
+       local mydistutilsargs=( build_src )
+       distutils-r1_python_install ${NUMPY_FCONFIG}
+       python_optimize
+}
+
+python_install_all() {
+       local DOCS=( LICENSE.txt README.md THANKS.txt )
+
+       if use doc; then
+               local HTML_DOCS=( "${WORKDIR}"/html/. )
+               DOCS+=( "${DISTDIR}"/${PN}-{user,ref}-${DOC_PV}.pdf )
+       fi
+
+       distutils-r1_python_install_all
+}

diff --git a/profiles/package.mask b/profiles/package.mask
index ca9a66a23a6..a9c3c04553f 100644
--- a/profiles/package.mask
+++ b/profiles/package.mask
@@ -32,6 +32,11 @@
 
 #--- END OF EXAMPLES ---
 
+# Michał Górny <[email protected]> (2021-02-07)
+# Fails tests (and does not seem to test the old installed version
+# at least partially).  Needs further testing.
+>=dev-python/numpy-1.20
+
 # Michał Górny <[email protected]> (2021-02-07)
 # Discontinued upstream.  Last release was for Xfce 4.12, last commit
 # in 2015.  Still uses GTK+2.

Reply via email to